const express = require('express');
const router = express.Router();
const authorize = require('../../../../middlewares/authorize-sapps');
const ageService = require('./age.service');

router.post('/create', authorize(), create);
router.post('/', authorize(), getAll);
router.post('/option', authorize(), option);
router.post('/option-free', option);
router.get('/count', authorize(), count);
router.put('/:id', authorize(), update);
router.put('/enabled/:id', authorize(), enabled);
router.delete('/:id', authorize(), _delete);

module.exports = router;

/**
 * Create a new age
 * @param {Object} req.body - The age data
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the created age
 */
function create(req, res, next) {
    ageService.create(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get a list of all ages
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of ages
 */
function getAll(req, res, next) {
    ageService.getAll(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Get an array of age objects to be used as options in a select box
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to an array of age objects
 */
function option(req, res, next) {
    ageService.option(req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Count the number of ages matching a query
 * @param {Object} req.query - The query object
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the count of ages
 */
function count(req, res, next) {
    ageService.count(req.query)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Update an existing age
 * @param {number} req.params.id - The age ID to be updated
 * @param {Object} req.body - The age data to be updated
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the updated age
 */
function update(req, res, next) {
    ageService.update(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Enable or disable a age
 * @param {number} req.params.id - The age ID to be enabled/disabled
 * @param {Object} req.body - The age data to be updated
 * @param {boolean} req.body.enabled - The enabled status of the age
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the enable/disable process
 */
function enabled(req, res, next) {
    ageService.enabled(req.params.id, req.body)
        .then(result => res.json(result))
        .catch(next);
}

/**
 * Delete a age
 * @param {number} req.params.id - The age ID to be deleted
 * @param {Object} res - The response object
 * @param {Function} next - The next middleware function
 * @returns {Promise} - A promise resolving to the result of the deletion process
 */
function _delete(req, res, next) {
    ageService.delete(req.params.id)
        .then(result => res.json(result))
        .catch(next);
}
